#TEMPLATE(SRmdi,'Steve: Serialize MDI access'),FAMILY('ABC')
#Extension(SRmdiSerialize,'Steve: Serialize MDI access global extension'),Application
#Sheet
  #Tab('General')
    #Display()
    #Display('Serialize MDI access by Steve Rothkin')
    #Display()
    #Display('This extension will add serialization code around key window')
    #Display('operations to protect global MDI structures.')
    #Display()
    #Display('Checking the following option will prevent generation of the')
    #Display('serialization code for this .app file.')
    #Display()
    #Prompt('Don''t serialize',Check),%NoMdiSerialize,at(10)
    #ENABLE(%NoMdiSerialize=0)
        #Prompt('Hourglass cursor while locking for open window?',Check),%OpenHourglass,default(1),at(10)
        #Prompt('Use event to unlock after window opened?',Check),%OpenUnlockOnEvent,default(1),at(10)
        #ENABLE(%OpenUnlockOnEvent)
            #PROMPT('Event code to use',@S6),%OpenEventCode,Req,DEFAULT('750h')
        #ENDENABLE
        #ENABLE(%OpenUnlockOnEvent=0)
            #Prompt('Open unlock end of init?',Check),%OpenUnlockEndInit,default(1),at(10)
            #ENABLE(%OpenUnlockEndInit=0)
                #Prompt('Serialize window resize',Check),%SerializeWindowResize,default(1),at(10)
                #Prompt('Serialize makeover window init',Check),%SerializeMakeoverInit,default(1),at(10)
            #ENDENABLE
        #ENDENABLE
        #Prompt('Debug Mode',Check),%DebugMdi,at(10)
        #Display('(requires DebugView from www.sysinternals.com)'),at(15)
    #ENDENABLE
    #Display()
  #EndTab
  #Tab('Multi-DLL')
    #Prompt('This is part of a Multi-DLL Application',Check),%IsMulti,AT(10),DEFAULT(0)
    #ENABLE(%IsMulti=%True)
        #PROMPT ('Define globals in this DLL',Check),%ThisDll,AT(10),DEFAULT(0)
        #Display ('should be checked in only 1 DLL, typically'),At(20)
        #DISPLAY('your data DLL.'),at(20)
        #Display()
    #ENDENABLE
  #EndTab
#EndSheet
#!------------------------------------------------------------------------------
#!  Define template globals
#!------------------------------------------------------------------------------
#ATSTART
#DECLARE( %DataDllAttr)
#IF((%IsMulti=1) and (%ThisDll=0))
#SET(%DataDllAttr,',EXTERNAL,DLL')
#ELSE
#SET(%DataDllAttr,'')
#ENDIF
#ENDAT
#!------------------------------------------------------------------------------
#at(%GlobalMap)
    #IF((%IsMulti=0) or (%ThisDll=1))
        module('')
             OutputDebugString(*cstring szOutputString),pascal,raw,name('OutputDebugStringA')
        end
        SRmdiDebugOut(string procname,string procmsg),NAME('SRmdiDebugOut')
    #else        
        module('')
            SRmdiDebugOut(string procname,string procmsg),NAME('SRmdiDebugOut'),DLL
        end
    #endif
#endat
#!------------------------------------------------------------------------------
#at(%ProgramProcedures),WHERE((%IsMulti=0) OR (%ThisDll=1))
! Generated by srmdi.tpl
! Function to write a message to OutputDebugString for viewing with DebugView
SRmdiDebugOut PROCEDURE(string procname,string procmsg)
OutMsg  cstring(1024)
    code

    OutMsg = 'SRMDI Thread ' & format(THREAD(),@n2) & ' ' & clip(procname) & ': ' & clip(procmsg) & '<13,10>'
    OutputDebugString(OutMsg)
        
#endat
#!------------------------------------------------------------------------------
#AT(%DLLExportList),PRIORITY(9900)
  #IF(%ThisDll)
    $SRmdiLockObj           @?
    SRmdiDebugOut           @?
  #endif    
#ENDAT
#!------------------------------------------------------------------------------
#AT(%DataSection)
#if(%NoMdiSerialize=0)
SRmdiCP CriticalProcedure   #<! Object to handle MDI locking/unlocking in this thread and gaurantee 
                            #<! lock is released when main procedure returns
#endif
#ENDAT
#!------------------------------------------------------------------------------
#AT(%GlobalData),first
#if( (%NoMdiSerialize=0) or %ThisDll)
 INCLUDE('CWSYNCHC.INC'),ONCE
#!SRmdiLockObj      &ICriticalSection %DataDllAttr  #<! Lock object to protect MDI window stuff   
SRmdiLockObj      &IMutex %DataDllAttr  #<! Lock object to protect MDI window stuff   
NoMdiSerialize  equate(%NoMdiSerialize)
#endif
#endat
#!------------------------------------------------------------------------------
#AT(%BeforeInitializingGlobalObjects),first
#if( (%IsMulti and %ThisDll) or ((%NoMdiSerialize=0) and (%IsMulti=0)) )
    #!SRmdiLockObj &= NewCriticalSection()
    SRmdiLockObj &= NewMutex()
    ASSERT(~SRmdiLockObj &= Null)
#endif
#endat
#!------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8000)
#!AT(%BeforeWindowOpening)
    #insert(%SROpenHourglassOn)
    #insert(%SRLockMdi,'Before window open')
    #insert(%SROpenHourglassOff)
    #insert(%SROpenHourglassOn)
#endat
#!------------------------------------------------------------------------------
#!AT(%AfterWindowOpening)
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(8001)
 #if(~%OpenUnlockEndInit and ~%OpenUnlockOnEvent)
    #insert(%SROpenHourglassOff)
    #insert(%SRUnLockMdi,'After window open')
 #endif    
#endat
#!------------------------------------------------------------------------------
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9998)
 #if(%OpenUnlockOnEvent)
    post(%OpenEventCode)    #<! SRMDI: post event to unlock mdi stuff after window init/open completes
 #elsif(%OpenUnlockEndInit)
    #insert(%SROpenHourglassOff)
    #insert(%SRUnLockMdi,'End of windowmanager init')
 #endif    
#endat
#!------------------------------------------------------------------------------
#AT(%EventCaseBeforeGenerated,'OpenWindow')
 #if(%OpenUnlockOnEvent)
    of %OpenEventCode   #<! SRMDI
        #insert(%SROpenHourglassOff)
        #insert(%SRUnLockMdi,'After window open done event')
 #endif
#endat
#!------------------------------------------------------------------------------
#AT(%BeforeWindowClosing)
    #insert(%SRLockMdi,'Before window close')
#endat
#!------------------------------------------------------------------------------
#AT(%AfterWindowClosing)
    #insert(%SRUnLockMdi,'After window close')
#endat
#!------------------------------------------------------------------------------
#AT(%BeforeWindowMakeover)
 #if(%SerializeMakeoverInit and ~%OpenUnlockEndInit)
    #insert(%SRLockMdi,'Before Makeover init')
 #endif    
#endat
#!------------------------------------------------------------------------------
#AT(%AfterWindowMakeover)
 #if(%SerializeMakeoverInit and ~%OpenUnlockEndInit)
    #insert(%SRUnLockMdi,'After Makeover init')
 #endif
#endat
#!------------------------------------------------------------------------------
#AT(%BeforeWindowIniResize)
  #IF(%INISaveWindow AND ~%DisableINISaveWindow and %SerializeWindowResize and ~%OpenUnlockEndInit)
    #insert(%SRLockMdi,'Before Init Resize')
  #endif    
#endat
#!------------------------------------------------------------------------------
#AT(%AfterWindowIniResize)
  #IF(%INISaveWindow AND ~%DisableINISaveWindow and %SerializeWindowResize and ~%OpenUnlockEndInit)
    #insert(%SRUnLockMdi,'After Init Resize')
  #endif    
#endat
#!------------------------------------------------------------------------------


#!---------------------------------------------------------------------------------------------------------------------------------------------------------
#CODE(SRmdiStart,'Steve: Start serialized MDI operation'),REQ(SRmdiSerialize)
#!---------------------------------------------------------------------------------------------------------------------------------------------------------
#BOXED('Procedure CODE')
  #DISPLAY ('')
  #DISPLAY ('Add this template before any')
  #DISPLAY ('MDI operation that you want serialized')
  #DISPLAY ('')
  #PROMPT('Step description (for debug output):',@s50),%LocText,Req
#ENDBOXED
    #insert(%SRLockMdi,%LocText)
    
#!---------------------------------------------------------------------------------------------------------------------------------------------------------
#CODE(SRmdiEnd,'Steve: End serialized MDI operation'),REQ(SRmdiSerialize)
#!---------------------------------------------------------------------------------------------------------------------------------------------------------
#BOXED('Procedure CODE')
  #DISPLAY ('')
  #DISPLAY ('Add this template after any')
  #DISPLAY ('MDI operation that you want serialized')
  #DISPLAY ('')
  #PROMPT('Step description (for debug output):',@s50),%LocText,Req
#ENDBOXED
    #insert(%SRUnLockMdi,%LocText)

#!---------------------------------------------------------------------------------------------------------------------------------------------------------
#CODE(SRmdiDebug,'Steve: Write debug string'),REQ(SRmdiSerialize)
#!---------------------------------------------------------------------------------------------------------------------------------------------------------
#BOXED('Procedure CODE')
  #DISPLAY ('')
  #DISPLAY ('Add this template to write debug output')
  #DISPLAY ('to DebugView (only when debug is checked')
  #DISPLAY ('on the global template)')
  #DISPLAY ('')
  #PROMPT('Message to write (quoted or variable):',@s250),%LocText,Req
#ENDBOXED
    #if(%DebugMdi)
    SRmdiDebugOut('%Application/%Procedure',%LocText)
    #endif



#!------------------------------------------------------------------------------
#GROUP(%SRLockMdi,%CallerLocation)
#if(%NoMdiSerialize=0)
    #if(%DebugMdi)
    SRmdiDebugOut('%Application/%Procedure','About to acquire lock (%CallerLocation)')
    #endif
    SRmdiCP.Init(SRmdiLockObj)   #<! Serialize key MDI operation
    #if(%DebugMdi)
    SRmdiDebugOut('%Application/%Procedure','Got lock (%CallerLocation)')
    #endif
#endif
#!------------------------------------------------------------------------------
#GROUP(%SRUnLockMdi,%CallerLocation)
#if(%NoMdiSerialize=0)
    #if(%DebugMdi)
    SRmdiDebugOut('%Application/%Procedure','About to release lock (%CallerLocation)')
    #endif
    SRmdiCP.Kill                 #<! Done with key MDI operation, release lock
    #if(%DebugMdi)
    SRmdiDebugOut('%Application/%Procedure','Released lock (%CallerLocation)')
    #endif
#endif
#!------------------------------------------------------------------------------
#GROUP(%SROpenHourglassOn)
#if(%OpenHourglass)
    SETCURSOR(CURSOR:Wait)  #<! SRMDI: Lock cursor while opening window
#endif
#!------------------------------------------------------------------------------
#GROUP(%SROpenHourglassOff)
#if(%OpenHourglass)
    SETCURSOR()             #<! SRMDI: Unlock cursor after window open
#endif
#!------------------------------------------------------------------------------
